#pragma once
#include "serializable.h"
//------------------------------------------------------------------------------

class CAddress : public ISerializable, public IObjectFactory
{
private:
	CString m_sCity;

public:
	void	SetCity(const CString&);
	CString	GetCity();

	// ISerializable interface
	int		GetProperties(CStringList& properties);
	bool	GetPropertyValue(const CString& sProperty, CProperty& sValue);
	bool	SetPropertyValue(const CString& sProperty, CProperty& sValue);	
	bool	HasMultipleInstances();									 
	CString GetClassName();
	CString GetID();

	// IObjectFactory
	ISerializable* Create();
	void		   Destroy(ISerializable*);
};

class CContact : public ISerializable, public IObjectFactory
{
private:
	CString		m_sFirstName;
	CString		m_sId;
	CAddress	m_address;
	CStringList m_emails;
	CPtrList	m_addresses;

public:
	CContact(void);
	~CContact(void);

	void	SetFirstName(const CString&);
	CString GetFirstName();

	void	SetId(const CString&);
	CString GetId();

	CStringList* GetEmailIds();
	CPtrList*	 GetAddressList();
	
	CAddress* GetAddress();

	// ISerializable interface
	int		GetProperties(CStringList& properties);
	bool	GetPropertyValue(const CString& sProperty, CProperty& sValue);
	bool	SetPropertyValue(const CString& sProperty, CProperty& sValue);	
	bool	HasMultipleInstances();									 
	CString GetClassName();
	CString GetID();

	// IObjectFactory
	ISerializable* Create();
	void		   Destroy(ISerializable*);
};
//------------------------------------------------------------------------------